
architecture dataflow of shifter is


component latch 
 generic(tpd_latch : Time);
 port (d : in std_logic;
       q : out std_logic;
       latch_en : std_logic);
end component;

signal fetch_status : std_logic;
signal decode_status : std_logic;
signal exec_status : std_logic;
signal mem_status : std_logic;
signal wb_status : std_logic;

signal next_stall : std_logic;

signal stall_fetch : std_logic;
signal stall_decode : std_logic;
signal stall_exec : std_logic;
signal stall_mem : std_logic;
signal stall_wb : std_logic;

begin

 stall_pipe_latch : latch
 generic map(tpd_latch => tpd_latch)
 port map (d => input(0),
           q => next_stall,
           latch_en => shift);

 fetch_latch : latch
 generic map(tpd_latch => tpd_latch)
 port map (d => fetch_status,
           q => stall_fetch,
           latch_en => shift);

 decode_latch : latch
 generic map(tpd_latch => tpd_latch)
 port map (d => decode_status,
           q => stall_decode,
           latch_en => shift);

 exec_latch : latch
 generic map(tpd_latch => tpd_latch)
 port map (d => exec_status,
           q => stall_exec,
           latch_en => shift);

 mem_latch : latch
 generic map(tpd_latch => tpd_latch)
 port map (d => mem_status,
           q => stall_mem,
           latch_en => shift);

 wb_latch : latch
 generic map(tpd_latch => tpd_latch)
 port map (d => wb_status,
           q => stall_wb,
           latch_en => shift);


 fetch_status <= next_stall and input(1);
 decode_status <= stall_fetch and input(2);
 exec_status <= stall_decode and input(3);
 mem_status <= stall_exec and input(4);
 wb_status <= stall_mem and input(5);

 output <= stall_fetch & stall_decode & stall_exec & stall_mem & stall_wb;


end dataflow;
