--------------------------------------------------------------------------
--  DLX PROCESSOR MODEL SUITE
--  Copyright (C) 1995, Martin Gumm
--  University of Stuttgart / Department of Computer Science / IPVR-ISE
--------------------------------------------------------------------------
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 1, or (at your option)
--  any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--------------------------------------------------------------------------
--  Last revision date : November 15 1995
--------------------------------------------------------------------------

--------------------------------------------------------------------------
--  *** SYNOPSYS synthesizable code (ver. 3.2.a) ***
--------------------------------------------------------------------------

--------------------------------------------------------------------------
--  Configuration for the DLX 
--  
--  (file datapath_config1.vhd)
--------------------------------------------------------------------------

configuration datapath_config1 OF datapath2 IS

  for structural

    for dp_alu : alu
      -- USE ENTITY WORK.alu(behaviour)
      USE configuration WORK.alu_config_rtl
        GENERIC MAP (tpd_latch => 2 ns,
                     tpd_out => 10 ns);
    end for; -- dp_alu
  	    
    for dp_reg_file : reg_file
      USE ENTITY WORK.reg_file(behaviour_5)
      --USE configuration WORK.reg_file_config_rtl
        GENERIC MAP (tpd_in => 4 ns,
                     tac => 4 ns);
    end for; -- dp_reg_file

    for iar_reg, tbr_reg, a_reg : word_reg_1e
      USE ENTITY WORK.word_reg_1e_ms(dataflow)
	GENERIC MAP (tpd_latch => 2 ns,
	             tpd_out => 2 ns);
    end for; -- iar_reg ...

    for b_reg, pc_1 : word_reg_1e1
      USE ENTITY WORK.word_reg_1e1_ms(dataflow)
	GENERIC MAP (tpd_latch => 2 ns,
	             tpd_out => 2 ns);
    end for; -- 

    for pc_adder : add_4_adder
      USE ENTITY WORK.add_4_adder(behaviour)
        GENERIC MAP (tpd_latch => 2 ns,
                     tpd_add => 4 ns);
    end for; -- pc_adder

    for lmdr_reg, smdr_reg : mdr2
      USE ENTITY WORK.mdr2(behaviour)
	GENERIC MAP (tpd_latch => 2 ns,
	             tpd_out => 2 ns,
		     tpd_logic => 2 ns);
    end for; -- lmdr, smdr

    FOR c_reg, aluout_reg, mar_reg, instr_reg, pc_reg, pc_2 : word_latch
      USE ENTITY WORK.word_latch_2(dataflow)
	GENERIC MAP (tpd_latch => 2 ns);
    end for; -- c_latch

    FOR icr_reg : icr2
      USE ENTITY WORK.icr2(dataflow)
	GENERIC MAP (tpd_latch => 2 ns,
	             tpd_out => 2 ns);
    end for; -- icr_reg

    FOR ir_1 : ir2
      USE ENTITY WORK.ir2(behaviour)
	GENERIC MAP (tpd_latch => 2 ns,
      	             tpd_out => 4 ns,	
	             DEBUG => true);
    end for; -- IR1

    FOR pc_mux, wb_mux, iar_mux, entry_mux, aluoutp_mux, set_mux : word_mux2
      USE ENTITY WORK.word_mux2(dataflow)
	GENERIC MAP (tpd_out => 2 ns);
    end for; -- entry_mux ...

    FOR alumux1, alumux2, smdr_mux, branch_reg_mux : word_mux4
      USE ENTITY WORK.word_mux4(dataflow)
        GENERIC MAP (tpd_out => 2 ns);
    end for;

    FOR zero_tester : zero_logic
      USE ENTITY WORK.zero_logic(dataflow)
        GENERIC MAP (tpd_logic => 2 ns);
    end for;

    FOR bus_const : bus_const32
      USE ENTITY WORK.bus_const32(dataflow)
	GENERIC MAP (tpd_out => 2 ns);
    end for; -- bus_const

  end for; -- datapath-structural

end datapath_config1;
