-- Behaviour of the memory stage

architecture behaviour of memory is

signal mem_ctrl : std_logic_vector(0 to 5);

signal c_latch : std_logic;
signal pc_mux   : std_logic;
signal lmdr_latch : std_logic;
signal mdr_ctrl : std_logic_vector(0 to 2);

signal wb_mux : std_logic;
signal rd : dlx_reg_addr;
signal rf_in : std_logic;

signal intrn_memory_not_ready : std_logic;

begin
-------------------------------------------------------------------------
 memory_input : process(phi1, reset)
 begin

 if reset = '0' then

  if phi1 = '1' then

     mem_ctrl <= mem_ctrl_in;
     entry_mux_out <= entry_mux_in;
     c_latch <= c_latch_in;

     pc_mux <= pc_mux_in;
     lmdr_latch <= lmdr_latch_in;
     mdr_ctrl <= lmdr_ctrl_in;
     --
     wb_mux <= wb_mux_in;
     rd <= rd_in;
     rf_in <= rf_in_in;

  end if; -- phi1  

 else -- reset = '1'

     mem_ctrl <= mem_none;
     pc_mux <= mar;

 end if; -- reset

 end process memory_input;


-- output for the write back stage
------------------------------------------------------------------------------
 wb_mux_out <= wb_mux;
 rf_in_out <= rf_in;
 rd_out <= rd;
------------------------------------------------------------------------------
  
-- control_output 
------------------------------------------------------------------------------
 c_latch_out <= c_latch;
 pc_mux_out <= pc_mux;
 lmdr_ctrl_out <= mdr_ctrl;

control_out : process(phi1, ready, lmdr_latch, mem_ctrl, adr_ls2)

begin

if reset = '0' then
 
 if phi1 = '1' then

    lmdr_latch_out <= lmdr_latch;
  
-- LMDR <- Mem[MAR] or Mem[MAR] <- SMDR

    mem_ctrl_out(4 to 7) <= mem_ctrl(2 to 5);

    case mem_ctrl(0 to 1) is
     when "11" =>
        mem_ctrl_out(0 to 3) <= "1111";
     when "10" =>
        case adr_ls2(1) is
            when '0' =>
               mem_ctrl_out(0 to 3) <= "1100";
            when '1' =>
               mem_ctrl_out(0 to 3) <= "0011";
            when others =>
               mem_ctrl_out(0 to 3) <= "0000";
        end case;
     when "01" =>
        case adr_ls2(1 downto 0) is
            when "00" =>
               mem_ctrl_out(0 to 3) <= "1000";
            when "01" =>
               mem_ctrl_out(0 to 3) <= "0100";
            when "10" =>
               mem_ctrl_out(0 to 3) <= "0010";
            when "11" =>
               mem_ctrl_out(0 to 3) <= "0001";
            when others =>
               mem_ctrl_out(0 to 3) <= "0000";
        end case;
     when others =>
        mem_ctrl_out(0 to 3) <= "0000";
    end case;


 else -- phi1 = '0'

  if not(mem_ctrl(0 to 1) = "00") then  -- load/store instr 

   if ready = '1' then

    mem_ctrl_out(0 to 3) <= "0000";
    intrn_memory_not_ready <= '0';
    lmdr_latch_out <= disable;

   else

    intrn_memory_not_ready <= '1';

   end if;

  end if;

 end if;

else -- reset = '1'

 intrn_memory_not_ready <= '0';

end if;

end process control_out;

memory_not_ready <= intrn_memory_not_ready;

end behaviour;
