-- memory stage of the pipeline

library IEEE;
use IEEE.std_logic_1164.all;

use WORK.dlx_types.all;
use WORK.control_types_2.all;

entity memory is

 port(phi1          : in std_logic;
      reset         : in std_logic;
      ready         : in std_logic;
      memory_not_ready : out std_logic;

      mem_ctrl_in : in std_logic_vector(0 to 5);
      entry_mux_in : in std_logic;
      c_latch_in : in std_logic;
      pc_mux_in : in std_logic;
      lmdr_latch_in : std_logic;
      lmdr_ctrl_in   : std_logic_vector(0 to 2);
      --
      --
      wb_mux_in : in std_logic;
      rf_in_in : in std_logic;
      rd_in    : in dlx_reg_addr;

-- shifted signals for write back stage

      wb_mux_out : out std_logic;
      rf_in_out  : out std_logic;
      rd_out     : out dlx_reg_addr;

-- control output lines

      mem_ctrl_out   : out std_logic_vector(0 to 7);   -- memory control lines
      entry_mux_out  : out std_logic;
      c_latch_out    : out std_logic;
      pc_mux_out     : out std_logic;
      lmdr_latch_out : out std_logic;
      lmdr_ctrl_out  : out std_logic_vector(0 to 2);
--
      adr_ls2        : in std_logic_vector(1 downto 0));
end memory;





